package data.campaign.econ;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.impl.campaign.ids.Commodities;
import com.fs.starfarer.api.impl.campaign.ids.Submarkets;
import com.fs.starfarer.api.impl.campaign.econ.BaseMarketConditionPlugin;

public class junk_pirates_ActiveMilitia extends BaseMarketConditionPlugin {

	public void apply(String id) {
		
		if (Global.getSector().getEconomy().isSimMode() && !market.hasSubmarket(Submarkets.GENERIC_MILITARY)) {
			market.addSubmarket(Submarkets.GENERIC_MILITARY);
		}
		
		market.getDemand(Commodities.SUPPLIES).getDemand().modifyFlat(id, junk_pirates_conditionData.MILITIA_BASE_SUPPLIES);
		market.getDemand(Commodities.FUEL).getDemand().modifyFlat(id, junk_pirates_conditionData.MILITIA_BASE_FUEL);
		market.getDemand(Commodities.HAND_WEAPONS).getDemand().modifyFlat(id, junk_pirates_conditionData.MILITIA_BASE_WEAPONS);
		market.getDemand(Commodities.HEAVY_MACHINERY).getDemand().modifyFlat(id, junk_pirates_conditionData.MILITIA_BASE_MACHINERY);
		
		market.getDemand(Commodities.MARINES).getDemand().modifyFlat(id, junk_pirates_conditionData.MILITIA_BASE_MARINES_DEMAND);
		market.getDemand(Commodities.MARINES).getNonConsumingDemand().modifyFlat(id, junk_pirates_conditionData.MILITIA_BASE_MARINES_DEMAND * junk_pirates_conditionData.CREW_MARINES_NON_CONSUMING_FRACTION);
		market.getDemand(Commodities.CREW).getDemand().modifyFlat(id, junk_pirates_conditionData.MILITIA_BASE_CREW_DEMAND);
		market.getDemand(Commodities.CREW).getNonConsumingDemand().modifyFlat(id, junk_pirates_conditionData.MILITIA_BASE_CREW_DEMAND * junk_pirates_conditionData.CREW_MARINES_NON_CONSUMING_FRACTION);
		
		market.getCommodityData(Commodities.MARINES).getSupply().modifyFlat(id, junk_pirates_conditionData.MILITIA_MARINES_SUPPLY);
		market.getCommodityData(Commodities.CREW).getSupply().modifyFlat(id, junk_pirates_conditionData.MILITIA_BASE_CREW_SUPPLY);
		
		//market.getStability().modifyFlat(id, ConditionData.STABILITY_MILITARY_BASE, "Military base");
	}

	public void unapply(String id) {
		market.getDemand(Commodities.SUPPLIES).getDemand().unmodify(id);
		market.getDemand(Commodities.FUEL).getDemand().unmodify(id);
		market.getDemand(Commodities.HAND_WEAPONS).getDemand().unmodify(id);
		market.getDemand(Commodities.HEAVY_MACHINERY).getDemand().unmodify(id);
		
		market.getDemand(Commodities.MARINES).getDemand().unmodify(id);
		market.getDemand(Commodities.MARINES).getNonConsumingDemand().unmodify(id);
		market.getDemand(Commodities.CREW).getDemand().unmodify(id);
		market.getDemand(Commodities.CREW).getNonConsumingDemand().unmodify(id);
		
		market.getCommodityData(Commodities.MARINES).getSupply().unmodify(id);
		market.getCommodityData(Commodities.CREW).getSupply().unmodify(id);
		
		//market.getStability().unmodify(id);
	}

}
