package data.campaign.econ;

import com.fs.starfarer.api.campaign.econ.MarketDemandAPI;
import com.fs.starfarer.api.impl.campaign.ids.Commodities;
import com.fs.starfarer.api.impl.campaign.econ.BaseMarketConditionPlugin;

public class junk_pirates_ResearchPost extends BaseMarketConditionPlugin {

	public void apply(String id) {
		float pop = getPopulation(market);
		
		market.getDemand(Commodities.CREW).getDemand().modifyFlat(id, junk_pirates_conditionData.RESEARCH_POST_CREW);
		market.getDemand(Commodities.CREW).getNonConsumingDemand().modifyFlat(id, junk_pirates_conditionData.RESEARCH_POST_CREW * junk_pirates_conditionData.CREW_MARINES_NON_CONSUMING_FRACTION);
		
		market.getDemand(Commodities.SUPPLIES).getDemand().modifyFlat(id, junk_pirates_conditionData.RESEARCH_POST_SUPPLIES);
		market.getDemand(Commodities.VOLATILES).getDemand().modifyFlat(id, junk_pirates_conditionData.RESEARCH_POST_VOLATILES);
		market.getDemand(Commodities.HEAVY_MACHINERY).getDemand().modifyFlat(id, junk_pirates_conditionData.RESEARCH_POST_MACHINERY);
		market.getDemand(Commodities.RARE_METALS).getDemand().modifyFlat(id, junk_pirates_conditionData.RESEARCH_POST_RARE_METALS);
		
		market.getCommodityData(Commodities.DRUGS).getSupply().modifyFlat(id, junk_pirates_conditionData.RESEARCH_POST_DRUGS);

		market.getStability().modifyFlat(id, junk_pirates_conditionData.STABILITY_RESEARCH_POST, "Research Outpost");
	}

	public void unapply(String id) {
		
		market.getDemand(Commodities.CREW).getDemand().unmodify(id);
		market.getDemand(Commodities.CREW).getNonConsumingDemand().unmodify(id);
		
		market.getDemand(Commodities.SUPPLIES).getDemand().unmodify(id);
		market.getDemand(Commodities.VOLATILES).getDemand().unmodify(id);
		market.getDemand(Commodities.HEAVY_MACHINERY).getDemand().unmodify(id);
		market.getDemand(Commodities.RARE_METALS).getDemand().unmodify(id);

		market.getCommodityData(Commodities.DRUGS).getSupply().unmodify(id);
		
		market.getStability().unmodify(id);
	}

}
