package data.scripts;

import com.fs.starfarer.api.BaseModPlugin;
import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.campaign.FactionAPI;
// Import every entry from your mod's data/world/generators.csv
import data.scripts.world.JunkGen;
//import data.scripts.omnifac.AddOmniFac;

import org.dark.shaders.util.ShaderLib;
import org.dark.shaders.light.LightData;
import org.dark.shaders.util.TextureData;
import exerelin.campaign.SectorManager;
import java.util.ArrayList;
import java.util.List;

public class JunkPiratesModPlugin extends BaseModPlugin
{

    private static final boolean isExerelin;
    
    static
    {
        boolean foundExerelin;
        try
        {
            Global.getSettings().getScriptClassLoader().loadClass("data.scripts.world.ExerelinGen");
            foundExerelin = true;
        }
        catch (ClassNotFoundException ex)
        {
            foundExerelin = false;
        }
        isExerelin = foundExerelin;
    }
    
    private static void initJunkPirates() {
        new JunkGen().generate(Global.getSector());
    }
    @Override
    public void onNewGameAfterEconomyLoad() {
        if (isExerelin && !SectorManager.getCorvusMode())
            {
                addNexerelinRandommodeShips();
            }
                         
    }
    @Override
    public void onNewGame() {
        if (isExerelin && !SectorManager.getCorvusMode())
            {
                return;
            }
        initJunkPirates();
    }
    
    public static void addNexerelinRandommodeShips() {
       
        List<String> aspships = new ArrayList<String>();
        
        aspships.add("syndicate_asp_hognose_p");
        aspships.add("syndicate_asp_kingcobra_p");
        aspships.add("syndicate_asp_diamondback_p");
        aspships.add("syndicate_asp_copperhead_p");
        aspships.add("syndicate_asp_gigantophis_p");
        
        FactionAPI faction = Global.getSector().getFaction("syndicate_asp");
        for (String id : aspships) {
            if (faction.knowsShip(id)) continue;
            faction.addKnownShip(id, true);
        }
    }


//    @Override
//    public void onNewGame()
//    {
//        // Calling a separate method avoids duplicate code with onEnabled()
//        initJunkPirates();
//    }

    @Override  
    public void onApplicationLoad()
    {  
        ShaderLib.init();  
        LightData.readLightDataCSV("data/lights/junk_pirates_light_data.csv");  
        TextureData.readTextureDataCSV("data/lights/junk_pirates_texture_data.csv");  
    }
}